# Copyright (C) 2008 Robert C. Kirby (Texas Tech University)
#
# This file is part of FIAT.
#
# FIAT is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# FIAT is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with FIAT. If not, see <http://www.gnu.org/licenses/>.

def factorial( n ):
    """Computes n! for n an integer >= 0.
    Raises an ArithmeticError otherwise."""
    if not isinstance(n, type(1)) or n < 0:
        raise ArithmeticError("factorial only defined on natural numbers.")
    f = 1
    for i in range(1, n+1):
        f = f * i
    return f

